git-stash.sh 8.2 KB
Newer Older
しらいしななこ 已提交
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
S
Stephen Boyd 已提交
6 7 8
   or: $dashless show [<stash>]
   or: $dashless drop [-q|--quiet] [<stash>]
   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9
   or: $dashless branch <branchname> [<stash>]
10 11
   or: $dashless [save [-k|--keep-index] [-q|--quiet] [<message>]]
   or: $dashless [-k|--keep-index]
12
   or: $dashless clear"
しらいしななこ 已提交
13

14
SUBDIRECTORY_OK=Yes
15
OPTIONS_SPEC=
しらいしななこ 已提交
16 17
. git-sh-setup
require_work_tree
18
cd_to_toplevel
しらいしななこ 已提交
19 20 21 22 23 24

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

T
Thomas Rast 已提交
25 26 27 28 29 30 31 32
if git config --get-colorbool color.interactive; then
       help_color="$(git config --get-color color.interactive.help 'red bold')"
       reset_color="$(git config --get-color '' reset)"
else
       help_color=
       reset_color=
fi

しらいしななこ 已提交
33
no_changes () {
34 35
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ 已提交
36 37 38
}

clear_stash () {
39 40 41 42
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
43
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
44
	then
E
Emil Medve 已提交
45
		git update-ref -d $ref_stash $current
46
	fi
しらいしななこ 已提交
47 48
}

J
Junio C Hamano 已提交
49
create_stash () {
50 51
	stash_msg="$1"

52
	git update-index -q --refresh
しらいしななこ 已提交
53 54 55 56
	if no_changes
	then
		exit 0
	fi
57

しらいしななこ 已提交
58
	# state of the base commit
59
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
60
	then
61
		head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
しらいしななこ 已提交
62 63 64 65
	else
		die "You do not have the initial commit yet"
	fi

66
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
67 68 69 70 71 72 73 74
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
75
	i_tree=$(git write-tree) &&
76
	i_commit=$(printf 'index on %s\n' "$msg" |
77
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
78 79
		die "Cannot save the current index state"

T
Thomas Rast 已提交
80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97
	if test -z "$patch_mode"
	then

		# state of the working tree
		w_tree=$( (
			rm -f "$TMP-index" &&
			cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
			GIT_INDEX_FILE="$TMP-index" &&
			export GIT_INDEX_FILE &&
			git read-tree -m $i_tree &&
			git add -u &&
			git write-tree &&
			rm -f "$TMP-index"
		) ) ||
			die "Cannot save the current worktree state"

	else

98
		rm -f "$TMP-index" &&
T
Thomas Rast 已提交
99 100 101 102 103 104 105 106
		GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&

		# find out what the user wants
		GIT_INDEX_FILE="$TMP-index" \
			git add--interactive --patch=stash -- &&

		# state of the working tree
		w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
しらいしななこ 已提交
107 108
		die "Cannot save the current worktree state"

T
Thomas Rast 已提交
109 110 111 112 113 114 115 116 117
		git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
		test -s "$TMP-patch" ||
		die "No changes selected"

		rm -f "$TMP-index" ||
		die "Cannot remove temporary index (can't happen)"

	fi

しらいしななこ 已提交
118
	# create the stash
119 120 121 122 123 124 125
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
126
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
127
		die "Cannot record working tree state"
J
Junio C Hamano 已提交
128
}
しらいしななこ 已提交
129

J
Junio C Hamano 已提交
130
save_stash () {
131
	keep_index=
T
Thomas Rast 已提交
132
	patch_mode=
S
Stephen Boyd 已提交
133 134 135
	while test $# != 0
	do
		case "$1" in
136
		-k|--keep-index)
S
Stephen Boyd 已提交
137 138
			keep_index=t
			;;
T
Thomas Rast 已提交
139 140 141 142 143 144 145
		--no-keep-index)
			keep_index=
			;;
		-p|--patch)
			patch_mode=t
			keep_index=t
			;;
S
Stephen Boyd 已提交
146 147 148 149 150 151 152
		-q|--quiet)
			GIT_QUIET=t
			;;
		*)
			break
			;;
		esac
153
		shift
S
Stephen Boyd 已提交
154
	done
155

156
	stash_msg="$*"
J
Junio C Hamano 已提交
157

158
	git update-index -q --refresh
J
Junio C Hamano 已提交
159 160
	if no_changes
	then
S
Stephen Boyd 已提交
161
		say 'No local changes to save'
J
Junio C Hamano 已提交
162 163 164 165 166 167
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
E
Emil Medve 已提交
168 169 170

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ 已提交
171

172
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
173
		die "Cannot save the current status"
S
Stephen Boyd 已提交
174
	say Saved working directory and index state "$stash_msg"
175

T
Thomas Rast 已提交
176
	if test -z "$patch_mode"
177
	then
T
Thomas Rast 已提交
178 179 180 181 182 183 184 185 186 187 188 189 190 191
		git reset --hard ${GIT_QUIET:+-q}

		if test -n "$keep_index" && test -n $i_tree
		then
			git read-tree --reset -u $i_tree
		fi
	else
		git apply -R < "$TMP-patch" ||
		die "Cannot remove worktree changes"

		if test -z "$keep_index"
		then
			git reset
		fi
192
	fi
しらいしななこ 已提交
193 194
}

195
have_stash () {
196
	git rev-parse --verify $ref_stash >/dev/null 2>&1
197 198
}

しらいしななこ 已提交
199
list_stash () {
200
	have_stash || return 0
201
	git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
しらいしななこ 已提交
202 203 204 205
	sed -n -e 's/^[.0-9a-f]* refs\///p'
}

show_stash () {
206
	flags=$(git rev-parse --no-revs --flags "$@")
しらいしななこ 已提交
207 208 209 210
	if test -z "$flags"
	then
		flags=--stat
	fi
211

212 213
	w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
	b_commit=$(git rev-parse --verify "$w_commit^") &&
214
	git diff $flags $b_commit $w_commit
しらいしななこ 已提交
215 216 217
}

apply_stash () {
218
	git update-index -q --refresh &&
219
	git diff-files --quiet --ignore-submodules ||
220
		die 'Cannot apply to a dirty working tree, please stage your changes'
しらいしななこ 已提交
221

222
	unstash_index=
S
Stephen Boyd 已提交
223 224 225 226 227 228 229 230 231 232 233 234 235 236

	while test $# != 0
	do
		case "$1" in
		--index)
			unstash_index=t
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
		*)
			break
			;;
		esac
237
		shift
S
Stephen Boyd 已提交
238
	done
239

しらいしななこ 已提交
240
	# current index state
241
	c_tree=$(git write-tree) ||
しらいしななこ 已提交
242 243
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
244 245
	# stash records the work tree, and is a merge between the
	# base commit (first parent) and the index tree (second parent).
246
	s=$(git rev-parse --verify --default $ref_stash "$@") &&
247
	w_tree=$(git rev-parse --verify "$s:") &&
J
Junio C Hamano 已提交
248 249
	b_tree=$(git rev-parse --verify "$s^1:") &&
	i_tree=$(git rev-parse --verify "$s^2:") ||
しらいしななこ 已提交
250 251
		die "$*: no valid stashed state found"

J
Junio C Hamano 已提交
252
	unstashed_index_tree=
253 254
	if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
			test "$c_tree" != "$i_tree"
J
Junio C Hamano 已提交
255
	then
256
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
257 258
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
259
		unstashed_index_tree=$(git write-tree) ||
260 261
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
262
	fi
263

しらいしななこ 已提交
264 265 266 267 268 269 270
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

S
Stephen Boyd 已提交
271 272 273 274
	if test -n "$GIT_QUIET"
	then
		export GIT_MERGE_VERBOSITY=0
	fi
275
	if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこ 已提交
276 277
	then
		# No conflict
J
Junio C Hamano 已提交
278 279 280
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
281 282
		else
			a="$TMP-added" &&
283
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
284 285 286 287
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
J
Junio C Hamano 已提交
288
		fi
S
Stephen Boyd 已提交
289 290 291 292 293 294
		squelch=
		if test -n "$GIT_QUIET"
		then
			squelch='>/dev/null 2>&1'
		fi
		eval "git status $squelch" || :
しらいしななこ 已提交
295 296
	else
		# Merge conflict; keep the exit status from merge-recursive
297
		status=$?
J
Junio C Hamano 已提交
298 299 300 301
		if test -n "$unstash_index"
		then
			echo >&2 'Index was not unstashed.'
		fi
302
		exit $status
しらいしななこ 已提交
303 304 305
	fi
}

306 307 308
drop_stash () {
	have_stash || die 'No stash entries to drop'

S
Stephen Boyd 已提交
309 310 311 312 313 314 315 316 317 318 319 320 321
	while test $# != 0
	do
		case "$1" in
		-q|--quiet)
			GIT_QUIET=t
			;;
		*)
			break
			;;
		esac
		shift
	done

322 323 324 325 326 327
	if test $# = 0
	then
		set x "$ref_stash@{0}"
		shift
	fi
	# Verify supplied argument looks like a stash entry
328
	s=$(git rev-parse --verify "$@") &&
329 330 331
	git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
	git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
	git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
332 333 334
		die "$*: not a valid stashed state"

	git reflog delete --updateref --rewrite "$@" &&
S
Stephen Boyd 已提交
335
		say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
336 337

	# clear_stash if we just dropped the last stash entry
338
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
339 340
}

341 342 343 344 345 346 347 348 349 350 351 352
apply_to_branch () {
	have_stash || die 'Nothing to apply'

	test -n "$1" || die 'No branch name specified'
	branch=$1

	if test -z "$2"
	then
		set x "$ref_stash@{0}"
	fi
	stash=$2

353
	git checkout -b $branch $stash^ &&
354 355 356 357
	apply_stash --index $stash &&
	drop_stash $stash
}

しらいしななこ 已提交
358 359
# Main command set
case "$1" in
360 361
list)
	shift
しらいしななこ 已提交
362 363 364 365 366 367 368 369 370 371 372
	if test $# = 0
	then
		set x -n 10
		shift
	fi
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
373 374
save)
	shift
375
	save_stash "$@"
376
	;;
しらいしななこ 已提交
377 378 379 380 381
apply)
	shift
	apply_stash "$@"
	;;
clear)
382 383
	shift
	clear_stash "$@"
しらいしななこ 已提交
384
	;;
J
Junio C Hamano 已提交
385 386 387 388 389 390 391
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
392 393 394 395
drop)
	shift
	drop_stash "$@"
	;;
396 397 398 399 400 401 402 403
pop)
	shift
	if apply_stash "$@"
	then
		test -z "$unstash_index" || shift
		drop_stash "$@"
	fi
	;;
404 405 406 407
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ 已提交
408
*)
409 410
	case $#,"$1","$2" in
	0,,|1,-k,|1,--keep-index,|1,-p,|1,--patch,|2,-p,--no-keep-index|2,--patch,--no-keep-index)
411
		save_stash "$@" &&
S
Stephen Boyd 已提交
412
		say '(To restore them type "git stash apply")'
413 414
		;;
	*)
415
		usage
416
	esac
417
	;;
しらいしななこ 已提交
418
esac